## mathgl 2.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

if(POLICY CMP0078)
    cmake_policy(SET CMP0078 OLD)
endif()
if(POLICY CMP0086)
    cmake_policy(SET CMP0086 OLD)
endif()

project( MathGL2 )

set(mgl_clean_files )
set(MGL_DEP_LIBS)
add_definitions(-DMGL_SRC)

#add_definitions(-DZLIB_WINAPI)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${MathGL2_SOURCE_DIR}/scripts)

if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are:
		None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif(NOT CMAKE_BUILD_TYPE)

set(CMAKE_VERBOSE_MAKEFILE ON)
set(MathGL_VERSION_MAJOR 2)
set(MathGL_VERSION_MINOR 5)
set(MathGL_PATCH_VERSION 0)
set(MathGL_VERSION ${MathGL_VERSION_MAJOR}.${MathGL_VERSION_MINOR}.${MathGL_PATCH_VERSION})
set(MathGL_SOVERSION 7.6.0)
string(TIMESTAMP MathGL_DATE UTC)

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
	option(enable-lcov "Enable coverage." OFF)
	if(enable-lcov)
		include(CodeCoverage)
		APPEND_COVERAGE_COMPILER_FLAGS()
	endif(enable-lcov)
else(CMAKE_BUILD_TYPE STREQUAL "Debug")
	unset(enable-lcov CACHE)
endif(CMAKE_BUILD_TYPE STREQUAL "Debug")

#set(CMAKE_CXX_OUTPUT_EXTENSION_REPLACE 1)
set(MathGL_INSTALL_LIB_DIR "lib" CACHE PATH "Installation directory for libraries")
set(MathGL_INSTALL_BIN_DIR "bin" CACHE PATH "Installation directory for executables")
set(MathGL_INSTALL_INCLUDE_DIR "include" CACHE PATH "Installation directory for headers")
if(WIN32 AND NOT CYGWIN)
	set(DEF_INSTALL_CMAKE_DIR cmake)
else()
	set(DEF_INSTALL_CMAKE_DIR lib/cmake/mathgl2)
endif()
set(MathGL_INSTALL_CMAKE_DIR ${DEF_INSTALL_CMAKE_DIR} CACHE PATH "Installation directory for CMake files")
# Make relative paths absolute (needed later on)
foreach(p LIB BIN INCLUDE CMAKE)
	set(var MathGL_INSTALL_${p}_DIR)
	if(NOT IS_ABSOLUTE "${${var}}")
		set(${var} "${CMAKE_INSTALL_PREFIX}/${${var}}")
	endif()
endforeach()

macro(mgl_po_src)
	set(l_files )
	foreach(src_file ${ARGN})
		get_filename_component(fp ${src_file} ABSOLUTE)
		file(RELATIVE_PATH rel ${CMAKE_SOURCE_DIR} ${fp})
		list(APPEND l_files "${rel}")
	endforeach(src_file ${ARGN})
	set(po_files ${po_files} ${l_files} PARENT_SCOPE)
endmacro(mgl_po_src)

function(mgl_add_lib mgl_tmp_lib)
	if(${mgl_tmp_lib} MATCHES mgl)
		set(mgllib mgl)
		set(mgllib2 mgl2)
	else(${mgl_tmp_lib} MATCHES mgl)
		set(mgllib mgl-${mgl_tmp_lib})
		set(mgllib2 mgl2-${mgl_tmp_lib})
	endif(${mgl_tmp_lib} MATCHES mgl)
	set(mgl_src_lst ${ARGV})
	list(REMOVE_AT mgl_src_lst 0)
	add_library(${mgllib} SHARED ${mgl_src_lst})
	add_library(${mgllib}-static STATIC ${mgl_src_lst})
	set_target_properties(${mgllib} PROPERTIES SOVERSION ${MathGL_SOVERSION})
	set_target_properties(${mgllib} PROPERTIES DEFINE_SYMBOL "mgl_EXPORTS")
	set_target_properties(${mgllib} PROPERTIES C_VISIBILITY_PRESET hidden)
	set_target_properties(${mgllib} PROPERTIES CXX_VISIBILITY_PRESET hidden)
	set_target_properties(${mgllib} PROPERTIES VISIBILITY_INLINES_HIDDEN 1)
	target_compile_definitions(${mgllib}-static PUBLIC MGL_STATIC_DEFINE)
	if(MSVC)
		set(mgl_lib_static "-static")
		set (CMAKE_DEBUG_POSTFIX "d")
		set_target_properties(${mgllib} PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX})
		set_target_properties(${mgllib}-static PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX})
#		if(CMAKE_BUILD_TYPE STREQUAL "Debug")
#			set(mgl_lib_end "d")
#		else(CMAKE_BUILD_TYPE STREQUAL "Debug")
#			set(mgl_lib_end)
#		endif(CMAKE_BUILD_TYPE STREQUAL "Debug")
	elseif(MSVC)
		set(mgl_lib_static)
		set_target_properties(${mgllib} PROPERTIES CLEAN_DIRECT_OUTPUT 1)
	set_target_properties(${mgllib}-static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
	endif(MSVC)
	if(enable-mgl2)
			set_target_properties(${mgllib} PROPERTIES OUTPUT_NAME "${mgllib2}${mgl_lib_end}")
			set_target_properties(${mgllib}-static PROPERTIES OUTPUT_NAME "${mgllib2}${mgl_lib_static}${mgl_lib_end}")
	else(enable-mgl2)
			set_target_properties(${mgllib} PROPERTIES OUTPUT_NAME "${mgllib}${mgl_lib_end}")
			set_target_properties(${mgllib}-static PROPERTIES OUTPUT_NAME "${mgllib}${mgl_lib_static}${mgl_lib_end}")
	endif(enable-mgl2)

	install(
			TARGETS ${mgllib} ${mgllib}-static
			EXPORT MathGLTargets
			RUNTIME DESTINATION ${MathGL_INSTALL_BIN_DIR}
			ARCHIVE DESTINATION ${MathGL_INSTALL_LIB_DIR}
			LIBRARY DESTINATION ${MathGL_INSTALL_LIB_DIR}
	)
endfunction(mgl_add_lib mgl_tmp_lib)

MACRO(MGL_DEPENDENT_OPTION option doc default depends1 force1 depends2 force2)
  IF(${option}_ISSET MATCHES "^${option}_ISSET$")
    SET(${option}_AVAILABLE 1)
    IF(${force1})
    FOREACH(d ${depends1})
      STRING(REGEX REPLACE " +" ";" CMAKE_DEPENDENT_OPTION_DEP "${d}")
      IF(${CMAKE_DEPENDENT_OPTION_DEP})
      ELSE(${CMAKE_DEPENDENT_OPTION_DEP})
          SET(${option}_AVAILABLE 0)
          SET(depends1_AVAILABLE 1)
      ENDIF(${CMAKE_DEPENDENT_OPTION_DEP})
    ENDFOREACH(d)
    ENDIF(${force1})
    IF(${force2})
    FOREACH(d ${depends2})
      STRING(REGEX REPLACE " +" ";" CMAKE_DEPENDENT_OPTION_DEP "${d}")
      IF(${CMAKE_DEPENDENT_OPTION_DEP})
      ELSE(${CMAKE_DEPENDENT_OPTION_DEP})
          SET(${option}_AVAILABLE 0)
          SET(depends2_AVAILABLE 1)
      ENDIF(${CMAKE_DEPENDENT_OPTION_DEP})
    ENDFOREACH(d)
    ENDIF(${force2})
    IF(${option}_AVAILABLE)
      OPTION(${option} "${doc}" "${default}")
      SET(${option} "${${option}}" CACHE BOOL "${doc}" FORCE)
    ELSE(${option}_AVAILABLE)
      IF(${option} MATCHES "^${option}$")
      ELSE(${option} MATCHES "^${option}$")
        SET(${option} "${${option}}" CACHE INTERNAL "${doc}")
      ENDIF(${option} MATCHES "^${option}$")
        IF(depends1_AVAILABLE)
          SET(${option} OFF)
        ELSEIF(depends2_AVAILABLE)
          SET(${option} ON)
        ENDIF(depends1_AVAILABLE)
    ENDIF(${option}_AVAILABLE)
  ELSE(${option}_ISSET MATCHES "^${option}_ISSET$")
    SET(${option} "${${option}_ISSET}")
  ENDIF(${option}_ISSET MATCHES "^${option}_ISSET$")
ENDMACRO(MGL_DEPENDENT_OPTION)
include(CMakeDependentOption)

string(TIMESTAMP MGL_NIGHT "%d.%m.%y")

if(WIN32)
	option(enable-dep-dll "Enable copying off all dependent dll libraries to the install directory" OFF)
endif(WIN32)

option(enable-double "Enable double precision in MathGL library" ON)
option(enable-mpi "Enable mpi")
option(enable-opengl "Enable OpenGL support" ON)
option(enable-all-docs "Enable all documentation building")
#option(enable-doc "Enable documentation building")
option(enable-all "Enable all core features")
option(enable-all-widgets "Enable all Widgets")
option(enable-all-swig "Enable all SWIG based interfaces")
option(enable-rvalue "Enable move constructor support (need C++11)" OFF)
option(enable-pthread "Enable POSIX threads support" OFF)
if(MSVC)
	option(enable-pthr-widget "Enable POSIX threads for widgets" OFF)
else(MSVC)
	option(enable-pthr-widget "Enable POSIX threads for widgets" ON)
endif(MSVC)
option(enable-openmp "Enable OpenMP support" ON)
option(disable-C99complex "Enable C99 complex number support" OFF)

if(enable-pthread AND enable-openmp)
	message(SEND_ERROR "You can't enable POSIX threads and OpenMP at the same time!")
endif(enable-pthread AND enable-openmp)

option(enable-lgpl "Enable only LGPL part of MathGL")
option(enable-mgl2 "Use names 'libmgl2-*' instead of 'libmgl-*'")
option(enable-ltdl "Enable loading modules support")
option(enable-doc-site "Enable HTML documentation for website")
#CMAKE_DEPENDENT_OPTION(enable-doc-site "Enable HTML documentation for website" OFF "NOT enable-all-docs" ON)
CMAKE_DEPENDENT_OPTION(enable-doc-html "Enable HTML documentation" OFF "NOT enable-all-docs" ON)
CMAKE_DEPENDENT_OPTION(enable-doc-info "Enable INFO documentation" OFF "NOT enable-all-docs" ON)
CMAKE_DEPENDENT_OPTION(enable-doc-pdf-ru "Enable Russian PDF documentation" OFF "NOT enable-all-docs" ON)
CMAKE_DEPENDENT_OPTION(enable-doc-pdf-en "Enable English PDF documentation" OFF "NOT enable-all-docs" ON)
#CMAKE_DEPENDENT_OPTION(enable-doc-prc "Enable PDF samples for HTML docs" OFF "NOT enable-all-docs" ON)
#CMAKE_DEPENDENT_OPTION(enable-doc-json "Enable JSON samples for HTML docs" OFF "NOT enable-all-docs" ON)
option(enable-texi2html "Use texi2html (obsolete package) instead of texi2any" OFF)
CMAKE_DEPENDENT_OPTION(enable-mgltex "Enable installation of mgltex package (MGL scripts in LATEX document)" OFF "NOT enable-lgpl" OFF)

CMAKE_DEPENDENT_OPTION(enable-zlib "Enable zlib support" ON "NOT enable-all" ON)
CMAKE_DEPENDENT_OPTION(enable-png "Enable png support" ON "NOT enable-all" ON)
CMAKE_DEPENDENT_OPTION(enable-jpeg "Enable jpeg support" OFF "NOT enable-all" ON)
MGL_DEPENDENT_OPTION(enable-gsl "Enable gsl support" OFF "NOT enable-lgpl" ON "NOT enable-all" ON)
MGL_DEPENDENT_OPTION(enable-hdf4 "Enable hdf4 support" OFF "NOT enable-lgpl" ON "NOT enable-all" ON)
MGL_DEPENDENT_OPTION(enable-hdf5 "Enable hdf5 support" OFF "NOT enable-lgpl" ON "NOT enable-all" ON)
CMAKE_DEPENDENT_OPTION(enable-pdf "Enable pdf support" OFF "NOT enable-all" ON)
CMAKE_DEPENDENT_OPTION(enable-gif "Enable gif support" OFF "NOT enable-all" ON)
CMAKE_DEPENDENT_OPTION(enable-arma "Enable Armadillo support" OFF "NOT enable-all" ON)
CMAKE_DEPENDENT_OPTION(enable-glut "Enable glut support" OFF "NOT enable-all-widgets" ON)
CMAKE_DEPENDENT_OPTION(enable-fltk "Enable fltk widget" OFF "NOT enable-all-widgets" ON)
CMAKE_DEPENDENT_OPTION(enable-wx "Enable wxWidget widget" OFF "NOT enable-all-widgets" ON)
CMAKE_DEPENDENT_OPTION(enable-qt "Enable Qt4 and/or Qt5 widget(s)" OFF "NOT enable-all-widgets" ON)
option(enable-qt4 "Enable Qt4 widget" OFF)
CMAKE_DEPENDENT_OPTION(enable-qt4asqt "Set Qt4 as default libmgl-qt" OFF "enable-qt4" OFF)
option(enable-qt5 "Enable Qt5 widget" OFF)
CMAKE_DEPENDENT_OPTION(enable-qt5asqt "Set Qt5 as default libmgl-qt" OFF "enable-qt5" OFF)
CMAKE_DEPENDENT_OPTION(enable-freetype "Enable freetype support" OFF "NOT enable-all" ON)
set(PY3VERSION_DOTTED "3.8" CACHE STRING "Used python version")
string(REPLACE "." "" PY3VERSION_NODOT ${PY3VERSION_DOTTED})

# msvc fwprintf print char* for the specifier of "%s" format
if(MSVC AND MSVC_VERSION GREATER 1899)
	SET(CMAKE_CXX_FLAGS "/EHsc -D_CRT_STDIO_ISO_WIDE_SPECIFIERS ${CMAKE_CXX_FLAGS}")
	SET(CMAKE_C_FLAGS "-D_CRT_STDIO_ISO_WIDE_SPECIFIERS ${CMAKE_C_FLAGS}")
endif(MSVC AND MSVC_VERSION GREATER 1899)

include(CheckCXXSourceCompiles)

if(${CMAKE_SIZEOF_VOID_P} EQUAL 4)
	set(CMAKE_REQUIRED_FLAGS -msse2 -mfpmath=sse)
	CHECK_CXX_SOURCE_COMPILES("
		int main(void){}" mgl_sse)
	if(mgl_sse)
		SET(CMAKE_CXX_FLAGS "-msse2 -mfpmath=sse ${CMAKE_CXX_FLAGS}")
		SET(CMAKE_C_FLAGS "-msse2 -mfpmath=sse ${CMAKE_C_FLAGS}")
	endif(mgl_sse)
	unset(CMAKE_REQUIRED_FLAGS)
endif(${CMAKE_SIZEOF_VOID_P} EQUAL 4)

if(enable-qt)
	FIND_PACKAGE(Qt4 4.8)
	if(Qt4_FOUND)
		set(enable-qt4 ON)
		find_package(Qt5 COMPONENTS Widgets)
		if(Qt5Widgets_FOUND)
			set(enable-qt5 ON)
		endif(Qt5Widgets_FOUND)
	else(Qt4_FOUND)
		set(enable-qt5 ON)
	endif(Qt4_FOUND)
endif(enable-qt)

if(enable-qt4 OR enable-qt5)
	set(QT_ENABLED ON)
	if(enable-qt4asqt AND enable-qt5asqt)
		message(SEND_ERROR "You cannot make Qt4 and Qt5 as qt at the same time.")
	endif(enable-qt4asqt AND enable-qt5asqt)
	if(enable-qt4 AND NOT enable-qt5)
		set(enable-qt4asqt TRUE)
	endif(enable-qt4 AND NOT enable-qt5)
	if(enable-qt5 AND NOT enable-qt4)
		set(enable-qt5asqt TRUE)
	endif(enable-qt5 AND NOT enable-qt4)
# 	if(NOT enable-opengl)
# 		message(SEND_ERROR "You cannot build MathGL with Qt4 or Qt5 without OpenGL enabled.")
# 	endif(NOT enable-opengl)
endif(enable-qt4 OR enable-qt5)

CMAKE_DEPENDENT_OPTION(enable-json-sample "Enable JSON sample (WebKit variant is the default)." ON "QT_ENABLED" OFF)
CMAKE_DEPENDENT_OPTION(enable-json-sample-we "Enable JSON sample (WebEngine variant)." OFF "enable-json-sample" OFF)
MGL_DEPENDENT_OPTION(enable-python "Enable python interface" OFF "NOT enable-lgpl" ON "NOT enable-all-swig" ON)
MGL_DEPENDENT_OPTION(enable-lua "Enable Lua (v.5.1) interface" OFF "NOT enable-lgpl" ON "NOT enable-all-swig" ON)

=== lang/CMakeLists.txt ===
set(src_imp_dep
../include/mgl2/type.h
../include/mgl2/data.h
../include/mgl2/mgl.h
mgl.i
data.i
type.i
)

set(mgl_clean_files "")

SET_SOURCE_FILES_PROPERTIES(mathgl.i numpy.i PROPERTIES CPLUSPLUS ON)

FIND_PACKAGE(SWIG)
if(NOT SWIG_FOUND)
	message(SEND_ERROR "Couldn't find swig needed for interfaces compiling.")
endif(NOT SWIG_FOUND)
INCLUDE(${SWIG_USE_FILE})

if(enable-python)
	set(Python_ADDITIONAL_VERSIONS ${PY3VERSION_DOTTED})
	FIND_PACKAGE(PythonInterp ${PY3VERSION_DOTTED} REQUIRED)
	if(NOT PYTHONINTERP_FOUND)
		message(SEND_ERROR "Couldn't find python interpreter.")
	endif(NOT PYTHONINTERP_FOUND)
	FIND_PACKAGE(PythonLibs ${PY3VERSION_DOTTED} REQUIRED)
	if(NOT PYTHONLIBS_FOUND)
		message(SEND_ERROR "Couldn't find python development libraries.")
	endif(NOT PYTHONLIBS_FOUND)
	execute_process(
		COMMAND ${PYTHON_EXECUTABLE} -c "import numpy; print (numpy.get_include())"
		OUTPUT_VARIABLE NUMPY_INCLUDE_PATH
		RESULT_VARIABLE NUMPY_ERR
		OUTPUT_STRIP_TRAILING_WHITESPACE
	)
	if(NOT NUMPY_INCLUDE_PATH)
		message(SEND_ERROR "Couldn't find numpy.")
	endif(NOT NUMPY_INCLUDE_PATH)

	include_directories(${PYTHON_INCLUDE_DIR}  ${NUMPY_INCLUDE_PATH})
	execute_process(
		COMMAND ${PYTHON_EXECUTABLE} -c "from distutils.sysconfig import get_python_lib; print (get_python_lib(prefix='${CMAKE_INSTALL_PREFIX}'))"
		OUTPUT_VARIABLE MGL_PYTHON_SITE_PACKAGES
		OUTPUT_STRIP_TRAILING_WHITESPACE)
	set(SWIG_MODULE_mathgl_EXTRA_DEPS numpy.i ${src_imp_dep})
	if(${CMAKE_VERSION} VERSION_LESS "3.8.0")
		SWIG_ADD_MODULE(mathgl python mathgl.i)
	else(${CMAKE_VERSION} VERSION_LESS "3.8.0")
		SWIG_ADD_LIBRARY(mathgl LANGUAGE python SOURCES mathgl.i)
	endif(${CMAKE_VERSION} VERSION_LESS "3.8.0")
	SWIG_LINK_LIBRARIES(mathgl mgl ${PYTHON_LIBRARIES})
	set_target_properties(_mathgl PROPERTIES BUILD_WITH_INSTALL_RPATH ON)
	add_custom_command(OUTPUT mathgl.pyc
		COMMAND ${PYTHON_EXECUTABLE}
		ARGS -c \"from py_compile import compile\; compile('mathgl.py') \"
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/lang
		DEPENDS _mathgl
	)
	add_custom_target(mgl_python_module ALL DEPENDS _mathgl mathgl.pyc)

	install(FILES ${MathGL2_BINARY_DIR}/lang/mathgl.py ${MathGL2_BINARY_DIR}/lang/__pycache__/mathgl.cpython-${PY3VERSION_NODOT}.pyc DESTINATION ${MGL_PYTHON_SITE_PACKAGES}/mathgl/__pycache__)
	install (TARGETS _mathgl LIBRARY DESTINATION ${MGL_PYTHON_SITE_PACKAGES}/mathgl)
	set(mgl_clean_files ${mgl_clean_files} mathgl.py)
endif(enable-python)

if(enable-lua)
	INCLUDE(FindLua51)
	if(NOT LUA51_FOUND)
		message(SEND_ERROR "Couldn't find Lua 5.1 library.")
	endif(NOT LUA51_FOUND)

	include_directories(${LUA_INCLUDE_DIR})
	set(SWIG_MODULE_mgl-lua_EXTRA_DEPS numpy.i ${src_imp_dep})
	if(${CMAKE_VERSION} VERSION_LESS "3.8.0") 
		SWIG_ADD_MODULE(mgl-lua lua mathgl.i)
	else(${CMAKE_VERSION} VERSION_LESS "3.8.0")
		SWIG_ADD_LIBRARY(mgl-lua LANGUAGE lua SOURCES mathgl.i)
	endif(${CMAKE_VERSION} VERSION_LESS "3.8.0")
	SWIG_LINK_LIBRARIES(mgl-lua mgl ${LUA_LIBRARIES})
	set_target_properties(mgl-lua PROPERTIES PREFIX "" BUILD_WITH_INSTALL_RPATH ON)

	install (TARGETS mgl-lua LIBRARY DESTINATION ${MathGL_INSTALL_LIB_DIR})
endif(enable-lua)

if(enable-octave)
	find_program(oct_prog octave-config)
	if(NOT oct_prog)
		message(SEND_ERROR "Couldn't find octave-config needed for octave interfaces compiling.")
	endif(NOT oct_prog)
	find_program(oct_exec octave)
	if(NOT oct_exec)
		message(SEND_ERROR "Couldn't find octave needed for octave interfaces compiling.")
	endif(NOT oct_exec)
	find_program(oct_mk mkoctfile)
	if(NOT oct_mk)
		message(SEND_ERROR "Couldn't find mkoctfile needed for octave interfaces compiling.")
	endif(NOT oct_mk)
	find_program(oct_tar tar)
	if(NOT oct_tar)
		message(SEND_ERROR "Couldn't find tar needed for octave interfaces creation.")
	endif(NOT oct_tar)

	execute_process(COMMAND ${oct_prog} -p CANONICAL_HOST_TYPE
	OUTPUT_VARIABLE oct_host
	OUTPUT_STRIP_TRAILING_WHITESPACE)
	execute_process(COMMAND ${oct_prog} -p API_VERSION
	OUTPUT_VARIABLE oct_api
	OUTPUT_STRIP_TRAILING_WHITESPACE)
	execute_process(COMMAND ${oct_mk} -p INCFLAGS
	OUTPUT_VARIABLE oct_inc
	OUTPUT_STRIP_TRAILING_WHITESPACE)
	separate_arguments(oct_inc)
message(STATUS "${oct_prog} ${oct_host} ${oct_api}")
	set(oct_arch ${oct_host}-${oct_api})
	set(pkg_name mathgl)
	set(mgl_pkg_dir ${MathGL2_BINARY_DIR}/lang/${pkg_name}/inst/${oct_arch})

	add_compile_options(${oct_inc})
	SET(SWIG_MODULE_mgl-oct_EXTRA_DEPS numpy.i ${src_imp_dep})
	if(${CMAKE_VERSION} VERSION_LESS "3.8.0") 
		SWIG_ADD_MODULE(mgl-oct octave mathgl.i)
	else(${CMAKE_VERSION} VERSION_LESS "3.8.0")
		SWIG_ADD_LIBRARY(mgl-oct LANGUAGE octave SOURCES mathgl.i)
	endif(${CMAKE_VERSION} VERSION_LESS "3.8.0")
	SWIG_LINK_LIBRARIES(mgl-oct mgl)
	set_target_properties(mgl-oct PROPERTIES OUTPUT_NAME mathgl PREFIX "" SUFFIX ".oct" BUILD_WITH_INSTALL_RPATH ON)
	add_custom_command(OUTPUT mathgl.tar.gz
		COMMAND ${CMAKE_COMMAND} -E make_directory ${mgl_pkg_dir}
		COMMAND ${CMAKE_COMMAND} -E copy ${MathGL2_SOURCE_DIR}/COPYING ${MathGL2_BINARY_DIR}/lang/${pkg_name}
		COMMAND ${CMAKE_COMMAND} -E copy ${MathGL2_SOURCE_DIR}/lang/DESCRIPTION ${MathGL2_BINARY_DIR}/lang/${pkg_name}
		COMMAND ${CMAKE_COMMAND} -E copy ${MathGL2_SOURCE_DIR}/lang/INDEX ${MathGL2_BINARY_DIR}/lang/${pkg_name}
		COMMAND ${CMAKE_COMMAND} -E copy ${MathGL2_SOURCE_DIR}/lang/PKG_ADD_template ${MathGL2_BINARY_DIR}/lang/${pkg_name}
		COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:mgl-oct> ${mgl_pkg_dir}
		COMMAND ${oct_tar} cpzf mathgl.tar.gz ${pkg_name}
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/lang
		DEPENDS mgl-oct
	)
	add_custom_target(mgl_octave_module ALL DEPENDS mathgl.tar.gz)

	install(FILES ${CMAKE_BINARY_DIR}/lang/mathgl.tar.gz DESTINATION ${MGL_DATA_PATH})
	if(enable-octave-install)
		install(CODE "execute_process(
			COMMAND ${oct_exec} -q --eval \"pkg install mathgl.tar.gz\"
			WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/lang )")
	endif(enable-octave-install)
	set(mgl_clean_files ${mgl_clean_files} mathgl)
endif(enable-octave)
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${mgl_clean_files}")

=== utils/CMakeLists.txt ===
add_executable(make_pas make_pas.cpp)

if(MSVC)
set(link_type -static)
else(MSVC)
set(link_type)
endif(MSVC)

add_executable(mgltask mgltask.cpp)
target_link_libraries(mgltask mgl${link_type} ${getopt_lib-static})
install(
	TARGETS mgltask
	EXPORT MathGLTargets
	RUNTIME DESTINATION ${MathGL_INSTALL_BIN_DIR}
)

add_executable(mglconv mglconv.cpp)
target_link_libraries(mglconv mgl${link_type} ${getopt_lib-static})
install(
	TARGETS mglconv
	EXPORT MathGLTargets
	RUNTIME DESTINATION ${MathGL_INSTALL_BIN_DIR}
)

add_executable(mgl.cgi mglcgi.cpp)
target_link_libraries(mgl.cgi mgl-static)
install(
	TARGETS mgl.cgi
	EXPORT MathGLTargets
# should be /usr/lib/cgi-bin/
	RUNTIME DESTINATION ${MGL_CGI_PATH}
)

mgl_po_src(mglconv.cpp mglview.cpp mglcgi.cpp mgltask.cpp)

if(MGL_HAVE_FLTK)
	add_definitions(-DUSE_FLTK)
	add_executable(mglview mglview.cpp)
	target_link_libraries(mglview mgl-fltk ${getopt_lib-static} ${FLTK_LIBRARIES})
	install(
		TARGETS mglview
		EXPORT MathGLTargets
		RUNTIME DESTINATION ${MathGL_INSTALL_BIN_DIR}
	)

else(MGL_HAVE_FLTK)
	if(QT_ENABLED)
		add_executable(mglview mglview.cpp)
		if(enable-qt5)
			include(../scripts/qt5.cmake)
			target_link_libraries(mglview mgl-qt5${link_type} ${getopt_lib-static} ${MGL_QT5_LIBS})
		else(enable-qt5)
			include(../scripts/qt4.cmake)
			target_link_libraries(mglview mgl-qt4${link_type} ${getopt_lib-static} ${MGL_QT4_LIBS})
		endif(enable-qt5)

		install(
			TARGETS mglview
			EXPORT MathGLTargets
			RUNTIME DESTINATION ${MathGL_INSTALL_BIN_DIR}
		)
	endif(QT_ENABLED)
endif(MGL_HAVE_FLTK)

=== debian/changelog ===
mathgl (2.5-2) unstable; urgency=medium

  * Team upload
  * Upload to unstable

 -- Rafael Laboissière <rafael@debian.org>  Fri, 24 Dec 2021 13:17:49 -0300

mathgl (2.5-1) experimental; urgency=medium

  * Team upload

  * Upload to experimental, due to the bump in the SOVERSION of the
    libraries and the name of the packages.

  * New upstream version 2.5
  * d/p/python3.patch: Drop patch (applied upstream)
  * d/control:
    + Adjust package names for new upstream SOVERSION
    + Tighten dependency on libmgl-data to the current source:Version
    + Bump Standards-Version to 4.6.0 (no changes needed)
    + Bump to debhelper compatibility level 13
    + Build-depend on desktop-file-utils
  * Adjust the names of the d/lib*.install files for new upstream SOVERSION
  * New scheme for enabling cmake modules
    + d/p/CMakeLists.patch: Drop patch
    + d/rules: Activate the modules through -D options to dh_auto_configure
  * New upstream installation path for Python files
    + d/python3-mathgl.install: Adjust for new upstream layout
    + d/not-installed: Ignore the .pyc file
  * d/mathgl.install: Include mgllab.desktop
  * d/udav.install: Fix location of udav.desktop
  * d/u/metadata: New file
  * d/rules: Drop dependency on libmgl-data for secondary libraries.
    All libmgl-*<soversion> libraries depend on the main library
    libmgl<soversion>, which depends on libmgl-data.
  * d/libmgl-data.install: Install the gettext (*.mo) files
  * d/libmgl-dev.install: Install the *.cmake files
  * d/libmgl-dev.examples: Install the examples

 -- Rafael Laboissière <rafael@debian.org>  Sat, 18 Dec 2021 05:01:32 -0300

mathgl (2.4.4-7) unstable; urgency=medium

  * Upload to unstable

 -- Rafael Laboissière <rafael@debian.org>  Wed, 09 Dec 2020 16:03:25 -0300

mathgl (2.4.4-7~exp) experimental; urgency=medium

  * Team upload
  * Disable building of the SWIG binding for Octave (Closes: #976381)
  * Bump Standards-Version to 4.5.1 (no changes needed)
  * Add Rules-Requires-Root: no
  * Fix wildcard matches in copyright file
  * Add DEP3 headers to the Debian patches
  * Bump version of watch file to 4

 -- Rafael Laboissière <rafael@debian.org>  Sun, 06 Dec 2020 05:37:53 -0300

=== debian/control ===
Source: mathgl
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>,
  Alastair McKinstry <mckinstry@debian.org>
Build-Depends:
 chrpath,
 cmake,
 debhelper-compat (= 13),
 desktop-file-utils,
 dh-sequence-python3,
 fluid,
 freeglut3-dev,
 libfltk1.3-dev,
 libfontconfig1-dev,
 libgif-dev,
 libgl1-mesa-dev | libgl-dev,
 libgsl-dev,
 libhdf4-dev,
 libhdf5-dev,
 libhpdf-dev,
 libjpeg-dev,
 libltdl-dev,
 liblua5.1-dev,
 libpng-dev,
 libqt5opengl5-dev,
 libqt5webkit5-dev,
 libtiff-dev,
 libwxgtk3.0-gtk3-dev,
 libxcursor-dev,
 libxft-dev,
 libxi-dev,
 libxinerama-dev,
 libxmu-dev,
 mpi-default-dev,
 python3-dev,
 python3-numpy,
 qtwebengine5-dev [amd64 arm64 armhf i386 mipsel],
 swig,
 texinfo,
 texlive,
 texlive-plain-generic
Standards-Version: 4.6.0
Homepage: http://mathgl.sourceforge.net/doc_en/Main.html
Vcs-Git: https://salsa.debian.org/science-team/mathgl.git
Vcs-Browser: https://salsa.debian.org/science-team/mathgl
Rules-Requires-Root: no

Package: mathgl
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl7.6.0 (= ${binary:Version})
Description: library for scientific graphs (utilities and examples)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains MathGL utilities and examples.

Package: udav
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl7.6.0 (= ${binary:Version})
Description: library for scientific graphs (window interface)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the udav window environment based on mathgl.

# Package: mathgl-doc-en
# Architecture: all
# Section: doc
# Depends: dpkg (>= 1.15.4) | install-info, ${misc:Depends}
# Replaces: mathgl-doc, mathgl-doc-ru
# Conflicts: mathgl-doc, mathgl-doc-ru
# Description: library for scientific graphs (English documentation)
#  A free cross-platform library of fast C++ routines for plotting data in up
#  to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
#  files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
#  MathGL can also be used in the console. There are interfaces to a set of
#  languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
#  .
#  This package contains the MathGL documentation in English.

Package: libmgl7.6.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl-data (= ${source:Version})
Replaces: libmgl7.4.1, libmgl7.5.0
Conflicts: libmgl7.4.1, libmgl7.5.0
Description: library for scientific graphs (main runtime library)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the shared object files.

Package: libmgl-mpi7.6.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl-data (= ${source:Version})
Replaces: libmgl-mpi7.4.1, libmgl-mpi7.5.0
Conflicts: libmgl-mpi7.4.1, libmgl-mpi7.5.0
Description: library for scientific graphs (mpi enhanced runtime library)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the, parallel interface enhanced, shared object
 files.

Package: libmgl-wnd7.6.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libmgl-fltk5, libmgl-wnd6, libmgl-qt5, libmgl-wx5,
 libmgl-wnd7.4.1, libmgl-wnd7.5.0
Conflicts: libmgl-fltk5, libmgl-wnd6, libmgl-qt5, libmgl-wx5,
 libmgl-wnd7.4.1, libmgl-wnd7.5.0
Description: library for scientific graphs (windows runtime library)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the window opening related shared object files based
 on Fltk, Qt and Wx.

Package: libmgl-glut7.6.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libmgl-glut5, libmgl-glut6.0.0, libmgl-glut7.1.0, libmgl-glut7.2.0,
 libmgl-glut7.4.0, libmgl-glut7.4.1, libmgl-glut7.5.0
Conflicts: libmgl-glut5, libmgl-glut6.0.0, libmgl-glut7.1.0, libmgl-glut7.2.0,
 libmgl-glut7.4.0, libmgl-glut7.4.1, libmgl-glut7.5.0
Description: library for scientific graphs (glut interface for windows)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the glut interface shared object files for window
 opening.

Package: libmgl-qt5-7.6.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libmgl-qt5, libmgl-qt7.1.0, libmgl-qt7.2.0, libmgl-qt7.4.0,
 libmgl-qt5-7.4.1, libmgl-qt5-7.5.0
Conflicts: libmgl-qt5, libmgl-qt7.1.0, libmgl-qt7.2.0, libmgl-qt7.4.0,
 libmgl-qt5-7.4.1, libmgl-qt5-7.5.0
Description: library for scientific graphs (Qt interface for windows)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the Qt interface shared object files for window
 opening.

Package: libmgl-fltk7.6.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libmgl-fltk7.4.1, libmgl-fltk7.5.0
Conflicts: libmgl-fltk7.4.1, libmgl-fltk7.5.0
Description: library for scientific graphs (fltk interface for windows)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the fltk interface shared object files for window
 opening.

Package: libmgl-wx7.6.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libmgl-wx7.4.1, libmgl-wx7.5.0
Conflicts: libmgl-wx7.4.1, libmgl-wx7.5.0
Description: library for scientific graphs (wx interface for windows)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the wx interface shared object files for window
 opening.

# Package: mgl-lua
# Architecture: any
# Section: libs
# Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl-data
# Description: library for scientific graphs (Lua interface)
#  A free cross-platform library of fast C++ routines for plotting data in up
#  to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
#  files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
#  MathGL can also be used in the console. There are interfaces to a set of
#  languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
#  .
#  This package contains the Lua interface shared object files.

Package: libmgl-data
Architecture: all
Multi-Arch: foreign
Section: misc
Depends: ${misc:Depends}
Description: library for scientific graphs (data files)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the MathGL data files.

Package: libmgl-dev
Architecture: any
Section: libdevel
Depends: libmgl7.6.0 (= ${binary:Version}), libmgl-wnd7.6.0 (= ${binary:Version}),
 libmgl-wx7.6.0 (= ${binary:Version}), libmgl-fltk7.6.0 (= ${binary:Version}),
 libmgl-qt5-7.6.0 (= ${binary:Version}), libmgl-glut7.6.0 (= ${binary:Version}),
 libmgl-mpi7.6.0 (= ${binary:Version}), ${misc:Depends}, libgsl-dev,
 libgl1-mesa-dev | libgl-dev, libpng-dev
Description: library for scientific graphs (development files)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the development files.

Package: python3-mathgl
Architecture: any
Section: python
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3,
 python3-numpy
Description: library for scientific graphs (Python module)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package provides the Python v.3 module for mathgl.
